# $Id: config.tcl 785 2006-11-04 22:42:43Z sergei $

# monkeys config file for Tkabber

# login settings
#set loginconf(user) User
#set loginconf(password) secret
#set loginconf(resource) tkabber
#set loginconf(server) jabber.ru
set autologin 0


# Login settings, common for all profiles
set loginconf(usedigest) 1
set loginconf(httpproxy) sun
set loginconf(httpproxyport) 3128
set loginconf(priority) 11
set loginconf(stream_options) encrypted

# Every 10 minutes send empty message to the server
# to avoid proxy disconnect
#set keep_alive 1
#set keep_alive_interval 10

# Also instead of above login settings you can setup few different profiles:

# !!!!!!!!!!!!!!Вот это отредактируй!!!!!!!!!!!!!!!!!
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
set loginconf1(profile)  "radhemouse"
set loginconf1(user)     имя_до_собаки
set loginconf1(password) введи_пароль
set loginconf1(server)   твой_сервер
set loginconf1(resource) tkabber


set loginconf2(profile)  "другоеназвание"
set loginconf2(user)     имя_до_собаки
set loginconf2(password) введи_пароль
set loginconf2(server)   твой_сервер
set loginconf2(resource) tkabber
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


# Set default profile
array set loginconf [array get loginconf1]



# Set sound module options
    #set sound::options(sound) 1
    #set sound::options(theme) "~/.tkabber/sounds"
    #set sound::options(external_play_program) "esdplay"



# 2.1.7 Splash window

    #set show_splash_window 1 



#hook::add finload_hook {
#    login [eval list [array get ::loginconf] [array get ::loginconf2]]
#    login [eval list [array get ::loginconf] [array get ::loginconf9]]
#} 10000

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Загрузка темы
#option readfile tkabber/examples/xrdb/yohho.xrdb userDefault

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Загрузка аватарки
#if {[file exists  $::configdir/avatar.gif]} {
#hook::add finload_hook {
  #avatar::load_file $::configdir/avatar.gif
#}
#} else {
 # avatar::load_file $::rootdir/pixmaps/default/tkabber/tkabber-logo.gif
#}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# переключениt между режимами ростера "все" и "только онлайн" по Alt-q
namespace eval ::ifacetk::roster {
  bind . <Alt-Key-q> +[namespace code {
    set show_only_online [expr {!$show_only_online}]
  }]
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# убить текст от начала строки до позиции курсора
bind Text <Control-BackSpace> { %W delete {insert linestart} insert}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# удалить текст от курсора до начала слова, содержащего позицию курсора,
# или до начала предыдущего слова, если курсор стоит между словами
bind Text <Alt-Key-BackSpace> { %W delete [tk::TextPrevPos %W insert tcl_startOfPreviousWord] insert }

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Ризоны для киков и банов одинаковые
# Меню киков
set my_kick_reasons {
  "Я ужасен ]:->"
  "Остынь, горячий финский парень!"
  "Следим за языком!!!"
  "Чужие здесь не ходят!"
  "Злостный оффтоп!!!"
  "БОТОВ НЕ ПРОСИТЬ!!!"
  "Я не люблю таких :-( обратно в лес - заниматься сексом с медведями"
  "Афтор, выпий йяду!!!"
  "Я тебя тоже люблю! ;)"
  "За наглость!"
  "За тупость!"
  "За длинный язык и плохие манеры..."
}
proc create_kick_presets_menu {m connid jid} {
  global my_kick_reasons
  menu $m
  foreach reason $my_kick_reasons {
    if {[string length $reason] > 25} {
      set label [string range $reason 0 22]...
    } else {
      set label $reason
    }
    $m add command -label $label \
      -command [list muc::change_item_param \
        {role none} down $connid $jid $reason]
  }
  set m
}
proc add_kick_presets {m connid jid} {
  set km $m.my_kick_menu
  create_kick_presets_menu $km $connid $jid
  $m add cascade -label "Указание кика" -menu $km
  $m add separator
}
hook::add roster_create_groupchat_user_menu_hook add_kick_presets
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Меню банов
proc create_ban_presets_menu {m connid jid} {
  global my_kick_reasons
  menu $m
  foreach reason $my_kick_reasons {
    if {[string length $reason] > 25} {
      set label [string range $reason 0 22]...
    } else {
      set label $reason
    }
    $m add command -label $label \
      -command [list muc::change_item_param \
        {affiliation outcast} down $connid $jid $reason]
  }
  set m
}
proc add_ban_presets {m connid jid} {
  set km $m.my_ban_menu
  create_ban_presets_menu $km $connid $jid
  $m add separator
  $m add cascade -label "Указание бана" -menu $km
}
hook::add roster_create_groupchat_user_menu_hook add_ban_presets
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# копирование рангов и ролей
proc add_copy_info_entry {m connid jid} {
  $m add command -label "Копировать инфо в буфер" \
    -command [double% [list copy_info_to_clipboard $connid $jid]]
}

proc copy_info_to_clipboard {connid jid} {
  variable ::muc::users

  set info ""
  foreach key {jid affiliation role} {
    upvar 0 ::muc::users($key,$connid,$jid) value
    if {[info exists value]} {
      if {$info != ""} {
        append info \n
      }
      append info [string totitle $key] ": " $value
    }
  }

  clipboard clear
  clipboard append -- $info
}

hook::add roster_create_groupchat_user_menu_hook add_copy_info_entry
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# добавление кнопки на панель
hook::add finload_hook {
  set b [[.mainframe gettoolbar 0].bbox add]
  $b configure \
    -highlightthickness 0 \
    -takefocus 0 -relief link \
    -bd $::tk_borderwidth \
    -padx 1 -pady 1 \
    -text XML \
    -helptext [::msgcat::mc "Open raw XML window"] \
    -command ::plugins::rawxml::open_window \
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

# Customize chat input window bindings
# копирование по контрлц
namespace eval my {}
proc my::tweak_chat_input_window {chatid type} {
  set cw [chat::chat_win $chatid]
  set iw [chat::input_win $chatid]

  bind $iw <<Copy>> [list \
    if {[string equal [selection own] %W]} [bind $iw <<Copy>>] \
    else [list event generate $cw <<Copy>>]
  ]
}
hook::add open_chat_post_hook my::tweak_chat_input_window
# Переключение Alt+ стрелки
hook::add finload_hook {
  bind . <Alt-Key-Left>  [bind . <Control-Key-Prior>]
  bind . <Alt-Key-Right> [bind . <Control-Key-Next>]
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

hook::add finload_hook {
        trace add variable ::textstatus read ::set_textstatus

        proc ::set_textstatus {var null op} {
            while {[regexp {(%[a|A|b|B|c|d|D|e|H|h|I|j|m|M|p|R|S|T|U|w|W|x|X|y|Y|Z])} \
            $::textstatus null format]} {
                regsub -all $format $::textstatus \
                    [clock format [clock seconds] -format $format] ::textstatus
            }
        }
} 100
